library tap_networking_module;

import 'dart:async';
import 'dart:convert';
import 'package:http/http.dart' as http;

class NetworkUtil {

  static String BASE_URL = "";
  static String URL_PATH = "";
  dynamic items;

  static NetworkUtil _instance = new NetworkUtil.internal();
  NetworkUtil.internal();

  factory NetworkUtil() => _instance;

  final JsonDecoder _decoder = new JsonDecoder();


  Future<dynamic> get(String baseUrl, String pathUrl,{Map<String, String> headers, encoding}) {
    String url = baseUrl + pathUrl;
    return http
        .get(
      url,
      headers: headers,
    )
        .then((http.Response response) {
      String res = response.body;
      int statusCode = response.statusCode;
      print("API Response: " + res);
      if (statusCode < 200 || statusCode > 400 || json == null) {
        res = "{\"status\":"+
            statusCode.toString() +
            ",\"message\":\"error\",\"response\":" +
            res +
            "}";
        throw new Exception( statusCode);
      }
      return _decoder.convert(res);
    });
  }


  void setTimeOutConnection(String url, int timeDuration){
    http.read(Uri.encodeFull(url),  headers: { "Accept": "application/json", "content-type" : "application/json"}).timeout( Duration(seconds: timeDuration));
  }

  Future<dynamic> post(String baseUrl, String pathUrl, var body)async{

    var bodyEncoded = json.encode(body);
    String url = baseUrl + pathUrl;
    return await http
        .post(Uri.encodeFull(url), body: bodyEncoded, headers: { "Accept": "application/json", "content-type" : "application/json"})
        .then((http.Response response) {
      //      print(response.body);
      final int statusCode = response.statusCode;
      if (statusCode < 200 || statusCode > 400 || json == null) {
        throw new Exception("Error while fetching data");
      }
      // return _decoder.convert(response.body);
      String res = response.body;
      items = _decoder.convert(res);
      return res;
    });
  }

  dynamic getItemDecoded(){
    return items;
  }


}
